---
title: Firefox 18 for developers
slug: Mozilla/Firefox/Releases/18
tags:
  - Firefox
  - Firefox 18
---
<div>{{FirefoxSidebar}}</div><p>Firefox 18 was released on January 8, 2013. This article lists key changes that are useful not only for web developers, but also Firefox and Gecko developers as well as add-on developers.</p>

<h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="HTML">HTML</h3>

<ul>
 <li>The {{htmlattrxref("reversed","ol")}} attribute of the {{HTMLElement("ol")}} element is now supported ({{bug("601912")}}).</li>
 <li>The {{htmlattrxref("crossorigin","link")}} attribute of the {{HTMLElement("link")}} element is now supported ({{bug("786564")}}).</li>
 <li>The {{htmlattrxref("allowfullscreen", "iframe")}} attribute of the {{HTMLElement("iframe")}} has been implemented and it's prefixed predecessor {{htmlattrxref("mozallowfullscreen", "iframe")}} is now deprecated.</li>
</ul>

<h3 id="CSS">CSS</h3>

<ul>
 <li>The {{cssxref("min-width")}} and {{cssxref("min-height")}} now uses the <code>auto</code> keyword as <em>initial value </em>(This has an effect only on flex items as it resolves to <code>0</code>, the previous initial value, for other items). ({{bug("763689")}})</li>
 <li>The cascade has been updated: now author <code>!important</code> rules override <a href="/en-US/docs/CSS/Using_CSS_animations" title="CSS/Using_CSS_animations">CSS animations</a>. ({{bug("783714")}})</li>
 <li>The {{cssxref("background")}} shorthand property now recognizes CSS3 {{cssxref("background-size")}} property specified inside. ({{bug("570326")}})</li>
 <li>Initial support for the CSS Flexbox Module has been landed. It is disabled by default but can be enabled by setting <code>layout.css.flexbox.enabled</code> to true. ({{bug('666041')}})</li>
</ul>

<h3 id="DOMAPIs">DOM/APIs</h3>

<ul>
 <li><code>navigator.mozPay</code> has been landed. ({{bug("767818")}})</li>
 <li><code>window.devicePixelRatio</code> has been landed. ({{bug("564815")}})</li>
 <li>The MacOS X backend for <code>window.navigator.battery</code> has been implemented. ({{bug("696045")}})</li>
 <li>{{domxref("BlobBuilder", "MozBlobBuilder")}} is removed. Developers need to use {{domxref("Blob")}} constuctor for creating a <code>Blob</code> object. ({{bug("744907")}})</li>
 <li>The {{event("visibilitychange")}} event and the <a href="/en-US/docs/DOM/Using_the_Page_Visibility_API" title="DOM/Using_the_Page_Visibility_API">Page Visibility API</a> has been unprefixed ({{bug("812086")}}).</li>
 <li>{{domxref("TextDecoder")}} and {{domxref("TextEncoder")}} have been added. Note that the implementation and spec of these evolved and have been changed in Firefox 19 ({{bug("764234")}}).</li>
 <li><code>HTMLMediaElement</code><code>.src</code> has been separate in two properties: the standard <code>src</code> property, dealing with {{domxref("DOMString")}}, and the prefixed <code>mozSrcObject</code> property, dealing with <a href="/en-US/docs/WebRTC/MediaStream_API" title="WebRTC/MediaStream_API">media streams</a> ({{bug("792665")}}).</li>
 <li>Support for <a href="/en-US/docs/DOM/Using_web_workers#Passing_data_by_transferring_.C2.A0ownership_%28transferable_objects%29" title="DOM/Using_web_workers#Passing_data_by_transferring_.C2.A0ownership_%28transferable_objects%29">transferable objects.</a></li>
 <li>The {{domxref("Screen.lockOrientation()")}} method now supports an <code>Array</code> of {{domxref("DOMString")}} as argument ({{bug("784549")}}.</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>Harmony's (ECMAScript 2015) <a href="/en-US/docs/JavaScript/Reference/Global_Objects/Proxy">Direct Proxies</a> have been landed ({{bug("703537")}}). Warning: the implementation contains a couple of known bugs, missing features and misalignements with the current state of the spec. Do not rely on it for production code.</li>
 <li>The ECMAScript 2015 <code>contains()</code> method is now implemented on strings. This is unfortunately not compatible with Mootools 1.2, which expects different behavior from <code>contains()</code> on strings but does not ensure it. Newer versions of Mootools fix this issue; sites should upgrade their Mootools version to something newer than 1.2.</li>
</ul>

<h3 id="WebGL">WebGL</h3>

<ul>
 <li>The prefixed version of the {{domxref("EXT_texture_filter_anisotropic")}} WebGL extension, "MOZ_EXT_texture_filter_anisotropic" has been removed ({{bug(790946)}}).</li>
</ul>

<h3 id="SVG">SVG</h3>

<h3 id="MathML">MathML</h3>

<h3 id="XUL">XUL</h3>

<h3 id="Network">Network</h3>

<ul>
 <li>Quality factors ("q-values") are now clamped to 2 digits (e.g. in HTTP {{HTTPHeader("Accept-Language")}} headers) ({{bug("672448")}}).</li>
 <li>The <code>ALLOW-FROM</code> syntax of the <a href="/en-US/docs/The_X-FRAME-OPTIONS_response_header" title="The_X-FRAME-OPTIONS_response_header"><code>X-FRAME-OPTIONS</code></a> HTTP Response header is now supported ({{bug("690168")}}).</li>
</ul>

<h3 id="Developer_tools">Developer tools</h3>

<h2 id="Changes_for_add-on_and_Mozilla_developers">Changes for add-on and Mozilla developers</h2>

<h3 id="Interface_changes">Interface changes</h3>

<dl>
 <dt>{{interface("nsIStreamListener")}}</dt>
 <dd>The 4th parameter (aOffset) of <code>onDataAvailable()</code> method changes to unsigned long long. ({{bug("784912")}})</dd>
 <dt>{{interface("nsIUploadChannel")}}</dt>
 <dd><code>setUploadStream()</code> supports over 2GB content-length ({{bug("790617")}})</dd>
 <dt>{{interface("nsIEditor")}}</dt>
 <dd><code>addEditorObserver()</code> has been removed, use <code>setEditorObserver()</code> instead, <code>removeEditorObserver()</code> no longer takes a {{interface("nsIEditorObserver")}} parameter ({{bug("785091")}})</dd>
 <dt>{{interface("nsIHttpProtocolHandler")}}</dt>
 <dd><code>http-on-modify-request</code> observers are no longer guaranteed to be called synchronously during<br>
 <code>nsIChannel.asyncOpen(). </code>For observers that need to be called during <code>asyncOpen</code>(), the new <code>http-on-opening-request</code> observer topic has been added. <code>See</code> ({{bug("800799")}})</dd>
 <dt>{{interface("nsIProtocolProxyService")}}</dt>
 <dd>The <code>resolve</code> method has been removed. Now, only the <code>asyncResolve</code> method can be used. See ({{bug("769764")}})</dd>
</dl>

<h4 id="New_interfaces">New interfaces</h4>

<h4 id="Removed_interfaces">Removed interfaces</h4>

<p>The following interfaces have been removed.</p>

<ul>
 <li>{{interface("nsIEditorObserver")}}</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="http://www.mozilla.org/en-US/firefox/18.0beta/releasenotes/">Firefox 18 Beta Release Notes</a></li>
 <li><a href="https://hacks.mozilla.org/2012/10/aurora-18-hidpi-touch-events/">Aurora 18: HiDPI &amp; Touch Events</a> (Mozilla Hacks)</li>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/18/">Site Compatibility for Firefox 18</a></li>
 <li><a href="https://blog.mozilla.org/addons/2012/12/28/compatibility-for-firefox-18/">Add-on Compatibility for Firefox 18</a> (Add-ons Blog)</li>
</ul>

<h3 id="Older_versions">Older versions</h3>

<div>{{Firefox_for_developers('17')}}</div>
